package com.lantone.structure.ai.process;


import com.alibaba.fastjson.JSONObject;
import com.lantone.structure.ai.model.EntityEnum;
import com.lantone.structure.ai.model.Lemma;
import com.lantone.structure.model.label.PreoperativeDiscussionLabel;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.util.List;

/**
 * 术前小结处理
 */
public class EntityProcessOperation extends EntityProcess {
    private Logger logger = LoggerFactory.getLogger(EntityProcessOperation.class);

    public PreoperativeDiscussionLabel extractEntity(JSONObject aiOut) {
        PreoperativeDiscussionLabel preoperativeDiscussionLabel= new PreoperativeDiscussionLabel();
        try {

            //过敏史
            List<Lemma> indicationAllergy = createEntityTree(aiOut, EntityEnum.ALLERGYRECORD.toString());
            for (Lemma lemma : indicationAllergy) {
                preoperativeDiscussionLabel.setAllergyRecord(lemma.getText());
            }

            //手术禁忌症
            List<Lemma> indicationOpContrain = createEntityTree(aiOut, EntityEnum.OPCONTRAINDICATION.toString());
            for (Lemma lemma : indicationOpContrain) {
                preoperativeDiscussionLabel.setOpContraindication(lemma.getText());
            }

            //拟实施手术目标部位名称
            List<Lemma> indicationOpBottom = createEntityTree(aiOut, EntityEnum.OPBOTTOMNAME.toString());
            for (Lemma lemma : indicationOpBottom) {
                preoperativeDiscussionLabel.setOpBottomName(lemma.getText());
            }
        } catch (Exception e) {
            e.printStackTrace();
            logger.error(e.getMessage(), e);
        }
        return preoperativeDiscussionLabel;
    }
}
